"use strict";
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  MixedValue: () => MixedValue,
  defaultLayers: () => figma_default_layers_default,
  dump: () => dump,
  fontsToLoad: () => fontsToLoad,
  insert: () => insert,
  isVisible: () => isVisible
});
module.exports = __toCommonJS(src_exports);

// src/readBlacklist.ts
var readBlacklist = /* @__PURE__ */ new Set([
  "parent",
  "stuckNodes",
  "__proto__",
  "instances",
  "removed",
  "exposedInstances",
  "attachedConnectors",
  "consumers",
  "hasMissingFont",
  "absoluteTransform",
  "absoluteRenderBounds",
  "absoluteBoundingBox",
  "vectorNetwork",
  "masterComponent",
  "selection",
  "hangingQuote",
  "playbackSettings",
  "listSpacing",
  "canUpgradeToNativeBidiSupport",
  "horizontalPadding",
  "verticalPadding"
]);
var _tooManyPoints = ["fillGeometry", "strokeGeometry"];
var _relativeTransformEtc = ["size", "relativeTransform"];
var _backgrounds = ["backgrounds", "backgroundStyleId"];
var _defaultBlacklist = /* @__PURE__ */ new Set([
  ...readBlacklist,
  "componentPropertyDefinitions"
]);
var _defaultBlacklistNoBackgrounds = /* @__PURE__ */ new Set([
  ..._defaultBlacklist,
  ..._backgrounds
]);
var _noGeometryBlacklist = /* @__PURE__ */ new Set([..._defaultBlacklist, ..._tooManyPoints]);
var _noGeometryNoBackgroundsBlacklist = /* @__PURE__ */ new Set([
  ..._noGeometryBlacklist,
  ..._backgrounds
]);
var _okToReadDefsWithGeomBlacklist = /* @__PURE__ */ new Set([
  ...readBlacklist,
  ..._backgrounds
]);
var _okToReadDefsNoGeomBlacklist = /* @__PURE__ */ new Set([
  ...readBlacklist,
  ..._tooManyPoints,
  ..._backgrounds
]);
var _textLayerNoGeomBlacklist = /* @__PURE__ */ new Set([
  ..._defaultBlacklistNoBackgrounds,
  ..._tooManyPoints,
  ..._relativeTransformEtc
]);
var _textLayerWithGeomBlacklist = /* @__PURE__ */ new Set([
  ..._tooManyPoints,
  ..._defaultBlacklistNoBackgrounds
]);
function isOkToReadBackgrounds(n) {
  return "type" in n && n.type === "PAGE";
}
function conditionalReadBlacklist(n, options) {
  const okToReadDefs = "type" in n && (n.type === "COMPONENT_SET" || n.type === "COMPONENT" && (!n.parent || n.parent.type !== "COMPONENT_SET"));
  const ignoreGeometry = options.geometry === "none";
  const isTextLayer = "type" in n && n.type === "TEXT";
  if (isTextLayer) {
    if (ignoreGeometry) {
      return _textLayerNoGeomBlacklist;
    } else {
      return _textLayerWithGeomBlacklist;
    }
  } else if (okToReadDefs) {
    if (ignoreGeometry) {
      return _okToReadDefsNoGeomBlacklist;
    } else {
      return _okToReadDefsWithGeomBlacklist;
    }
  } else if (isOkToReadBackgrounds(n)) {
    if (ignoreGeometry) {
      return _noGeometryBlacklist;
    } else {
      return _defaultBlacklist;
    }
  } else {
    if (ignoreGeometry) {
      return _noGeometryNoBackgroundsBlacklist;
    } else {
      return _defaultBlacklistNoBackgrounds;
    }
  }
}

// src/figmaState.ts
var skipState;
function saveFigmaState(skipInvisibleInstanceChildren) {
  if ("figma" in globalThis) {
    skipState = figma.skipInvisibleInstanceChildren;
    figma.skipInvisibleInstanceChildren = skipInvisibleInstanceChildren;
  }
}
function restoreFigmaState() {
  if ("figma" in globalThis && skipState !== void 0) {
    figma.skipInvisibleInstanceChildren = skipState;
    skipState = void 0;
  }
}

// src/read.ts
function isVisible(n) {
  if (typeof n !== "object") {
    return true;
  }
  if (!("visible" in n) || typeof n.visible !== "boolean" || !("opacity" in n) || typeof n.opacity !== "number" || !("removed" in n) || typeof n.removed !== "boolean") {
    return true;
  }
  return n.visible && n.opacity > 1e-3 && !n.removed;
}
var defaultOptions = {
  skipInvisibleNodes: true,
  images: false,
  geometry: "none",
  styles: false,
  maxDepth: Infinity
};
var DumpContext = class {
  constructor(options) {
    this.options = options;
    this.imageHashes = /* @__PURE__ */ new Set();
    this.components = {};
    this.componentSets = {};
    this.styles = {};
    this.depth = 0;
  }
  pushParent() {
    this.depth++;
  }
  popParent() {
    this.depth--;
  }
};
function _dumpObject(n, keys, ctx) {
  return keys.reduce((o, k) => {
    var _a;
    const v = n[k];
    if (k === "imageHash" && typeof v === "string") {
      ctx.imageHashes.add(v);
    } else if (k.endsWith("StyleId") && typeof v === "string" && v.length > 0 && ctx.options.styles) {
      const style = figma.getStyleById(v);
      if (style) {
        ctx.styles[style.id] = {
          key: style.key,
          name: style.name,
          styleType: style.type,
          remote: style.remote,
          description: style.description
        };
      } else {
        console.warn(`Couldn't find style with id ${v}.`);
      }
    } else if (k === "mainComponent" && v) {
      const component = v;
      let componentSetId;
      if (((_a = component.parent) == null ? void 0 : _a.type) === "COMPONENT_SET") {
        const componentSet = component.parent;
        const { name: name2, description: description2, documentationLinks: documentationLinks2, key: key2, remote: remote2 } = componentSet;
        componentSetId = componentSet.id;
        ctx.componentSets[componentSet.id] = {
          key: key2,
          name: name2,
          description: description2,
          remote: remote2,
          documentationLinks: documentationLinks2
        };
      }
      const { name, key, description, documentationLinks, remote } = component;
      ctx.components[component.id] = {
        key,
        name,
        description,
        remote,
        componentSetId,
        documentationLinks
      };
      o["componentId"] = v.id;
      return o;
    } else if (k === "children") {
      if (ctx.depth >= ctx.options.maxDepth) {
        if (ctx.options.childrenReplacement) {
          o[k] = [ctx.options.childrenReplacement];
        } else {
          o[k] = [];
        }
      } else {
        ctx.pushParent();
        o[k] = _dump(v, ctx);
        ctx.popParent();
      }
      return o;
    }
    o[k] = _dump(v, ctx);
    return o;
  }, {});
}
function _dump(n, ctx) {
  switch (typeof n) {
    case "object": {
      if (Array.isArray(n)) {
        return n.filter((v) => !ctx.options.skipInvisibleNodes || isVisible(v)).map((v) => _dump(v, ctx));
      } else if (n === null) {
        return null;
      } else if (n.__proto__ !== void 0) {
        const blacklistKeys = conditionalReadBlacklist(n, ctx.options);
        const keys = [...Object.keys(n), ...Object.keys(n.__proto__)].filter(
          (k) => !blacklistKeys.has(k)
        );
        return _dumpObject(n, keys, ctx);
      } else {
        const keys = Object.keys(n);
        return _dumpObject(n, keys, ctx);
      }
    }
    case "function":
      return void 0;
    case "symbol":
      if (n === figma.mixed) {
        return "__Symbol(figma.mixed)__";
      } else {
        return String(n);
      }
    default:
      return n;
  }
}
function requestImages(ctx) {
  return __async(this, null, function* () {
    const imageRequests = [...ctx.imageHashes].map((hash) => __async(this, null, function* () {
      const im = figma.getImageByHash(hash);
      if (im === null) {
        throw new Error(`Image not found: ${hash}`);
      }
      const dat = yield im.getBytesAsync();
      return [hash, dat];
    }));
    const r = yield Promise.all(imageRequests);
    return Object.fromEntries(r);
  });
}
function dump(_0) {
  return __async(this, arguments, function* (n, options = {}) {
    const resolvedOptions = __spreadValues(__spreadValues({}, defaultOptions), options);
    const { skipInvisibleNodes } = resolvedOptions;
    saveFigmaState(skipInvisibleNodes);
    const ctx = new DumpContext(resolvedOptions);
    const objects = n.filter((v) => !skipInvisibleNodes || isVisible(v)).map((o) => _dump(o, ctx));
    const images = resolvedOptions.images ? yield requestImages(ctx) : {};
    restoreFigmaState();
    const { components, componentSets, styles } = ctx;
    return {
      objects,
      components,
      componentSets,
      styles,
      images
    };
  });
}

// src/applyOverridesToChildren.ts
function isSupported(property) {
  return property === "characters" || property === "opacity";
}
function filterNulls(arr) {
  return arr.filter((n) => n !== null);
}
function applyOverridesToChildren(instance, f) {
  const { overrides } = f;
  if (!overrides) {
    return;
  }
  const supportedOverrides = filterNulls(
    overrides.map(
      ({ id, overriddenFields }) => {
        const sp = overriddenFields.filter(isSupported);
        return sp.length > 0 ? [id, sp] : null;
      }
    )
  );
  const overriddenMap = new Map(
    supportedOverrides
  );
  _recursive(instance, f, overriddenMap);
}
function _recursive(n, f, overriddenMap) {
  if (n.children.length !== f.children.length) {
    console.warn(
      `Instance children length mismatch ${n.children.length} vs ${f.children.length}: `,
      n,
      f
    );
  }
  for (let [node, json] of zip(n.children, f.children)) {
    if (node.type !== json.type) {
      console.warn(
        `Instance children type mismatch: ${node.type} !== ${json.type}`
      );
    }
    _applyOverrides(node, json, overriddenMap);
    if ("children" in node && "children" in json) {
      _recursive(node, json, overriddenMap);
    }
  }
}
function _applyOverrides(n, j, overriddenMap) {
  const overriddenFields = overriddenMap.get(j.id);
  if (overriddenFields) {
    for (let property of overriddenFields) {
      const v = j[property];
      n[property] = v;
    }
  }
}
function* zip(a, b) {
  let iterA = a[Symbol.iterator]();
  let iterB = b[Symbol.iterator]();
  let nextA = iterA.next();
  let nextB = iterB.next();
  while (!nextA.done && !nextB.done) {
    yield [nextA.value, nextB.value];
    nextA = iterA.next();
    nextB = iterB.next();
  }
}

// src/figma-json.ts
var MixedValue = "__Symbol(figma.mixed)__";

// src/updateImageHashes.ts
function updateImageHashes(n, updates) {
  n = __spreadValues({}, n);
  if ("children" in n && n.children !== void 0) {
    const children = n.children.map((c) => updateImageHashes(c, updates));
    n = __spreadProps(__spreadValues({}, n), { children });
  }
  const fixFills = (fills) => {
    return fills.map((f) => {
      if (f.type === "IMAGE" && typeof f.imageHash === "string") {
        const imageHash = updates.get(f.imageHash) || null;
        if (typeof f.imageHash === "string") {
          return __spreadProps(__spreadValues({}, f), { imageHash });
        } else {
          return f;
        }
      } else {
        return f;
      }
    });
  };
  if ("fills" in n && n.fills !== void 0 && n.fills !== "__Symbol(figma.mixed)__") {
    n.fills = fixFills(n.fills);
  }
  return n;
}

// src/fallbackFonts.ts
var fallbackFonts = [
  { family: "Inter", style: "Regular" },
  { family: "Inter", style: "Thin" },
  { family: "Inter", style: "Extra Light" },
  { family: "Inter", style: "Light" },
  { family: "Inter", style: "Medium" },
  { family: "Inter", style: "Semi Bold" },
  { family: "Inter", style: "Bold" },
  { family: "Inter", style: "Extra Bold" },
  { family: "Inter", style: "Black" }
];

// src/write.ts
var writeBlacklist = /* @__PURE__ */ new Set([
  "id",
  "componentPropertyReferences",
  "variantProperties",
  "overlayPositionType",
  "overlayBackground",
  "overlayBackgroundInteraction",
  "fontWeight",
  "overrides",
  "componentProperties",
  "inferredAutoLayout",
  "componentId",
  "isAsset"
]);
function notUndefined(x) {
  return x !== void 0;
}
function loadFonts(requestedFonts, fallbackFonts2) {
  return __async(this, null, function* () {
    const availableFonts = [];
    const missingFonts = [];
    const fontReplacements = {};
    const loadFontPromises = requestedFonts.map((fontName) => __async(this, null, function* () {
      try {
        yield figma.loadFontAsync(fontName);
        availableFonts.push(fontName);
      } catch (e) {
        console.warn(`Unable to load font: ${encodeFont(fontName)}`);
        missingFonts.push(fontName);
        const replacement = getFontReplacement(fontName, fallbackFonts2);
        console.log(`Trying font replacement: ${encodeFont(replacement)}`);
        try {
          yield figma.loadFontAsync(replacement);
          console.log(`Loaded font replacement: ${encodeFont(replacement)}`);
          fontReplacements[encodeFont(fontName)] = encodeFont(replacement);
        } catch (e2) {
          console.warn(
            `Unable to load font replacement: ${encodeFont(replacement)}`
          );
          fontReplacements[encodeFont(fontName)] = encodeFont(fallbackFonts2[0]);
        }
      }
    }));
    yield Promise.all(loadFontPromises);
    console.log("done loading fonts.");
    return { availableFonts, missingFonts, fontReplacements };
  });
}
function loadComponents(requestedComponents) {
  return __async(this, null, function* () {
    const availableComponents = {};
    yield Promise.all(
      Object.entries(requestedComponents).map((_0) => __async(this, [_0], function* ([id, requested]) {
        try {
          const component = yield figma.importComponentByKeyAsync(requested.key);
          availableComponents[id] = component;
        } catch (e) {
          const node = figma.getNodeById(id);
          if (node && node.type === "COMPONENT") {
            availableComponents[id] = node;
          } else {
            console.log("error loading component:", e);
          }
        }
      }))
    );
    return { availableComponents };
  });
}
function loadStyles(requestedStyles) {
  return __async(this, null, function* () {
    yield Promise.all(
      Object.entries(requestedStyles).map((_0) => __async(this, [_0], function* ([id, requested]) {
        try {
          yield figma.importStyleByKeyAsync(requested.key);
        } catch (e) {
          console.log("error loading style:", e);
        }
      }))
    );
  });
}
function encodeFont({ family, style }) {
  if (family.includes("|") || style.includes("|")) {
    throw new Error(`Cannot encode a font with "|" in the name.`);
  }
  return [family, style].join("|");
}
function decodeFont(f) {
  const s = f.split("|");
  if (s.length !== 2) {
    throw new Error(`Unable to decode font string: ${f}`);
  }
  const [family, style] = s;
  return { family, style };
}
function applyFontName(n, fontName, fontReplacements) {
  return __async(this, null, function* () {
    if (fontName === "__Symbol(figma.mixed)__") {
      return;
    }
    const replacement = fontReplacements[encodeFont(fontName)];
    if (replacement) {
      n.fontName = decodeFont(replacement);
      return;
    }
    n.fontName = fontName;
  });
}
function getFontReplacement(missingFont, fallbackFonts2) {
  const replacement = fallbackFonts2.find((f) => f.style === missingFont.style);
  if (replacement) {
    return replacement;
  }
  return fallbackFonts2[0];
}
function resizeOrLog(f, width, height, withoutConstraints) {
  if (width > 0.01 && height > 0.01) {
    if (withoutConstraints) {
      f.resizeWithoutConstraints(width, height);
    } else {
      f.resize(width, height);
    }
  } else {
    const generic = f;
    const { type } = generic;
    console.log(
      `Couldn't resize item: ${JSON.stringify({
        type,
        width,
        height
      })}`
    );
  }
}
function fontsToLoad(n) {
  const fonts = /* @__PURE__ */ new Set();
  const addFonts = (json) => {
    switch (json.type) {
      case "COMPONENT":
      case "INSTANCE":
      case "FRAME":
      case "GROUP":
        const { children = [] } = json;
        children.forEach(addFonts);
        return;
      case "TEXT":
        const { fontName } = json;
        if (typeof fontName === "object") {
          fonts.add(encodeFont(fontName));
        } else if (fontName === "__Symbol(figma.mixed)__") {
          console.log("encountered mixed fontName: ", fontName);
        }
    }
  };
  try {
    n.objects.forEach(addFonts);
  } catch (err) {
    console.error("error searching for fonts:", err);
  }
  const fontNames = [...fonts].map((fstr) => decodeFont(fstr));
  return fontNames;
}
function safeAssign(n, dict) {
  for (let k in dict) {
    try {
      if (writeBlacklist.has(k)) {
        continue;
      }
      const v = dict[k];
      if (v === MixedValue || v === void 0) {
        continue;
      }
      n[k] = v;
    } catch (error) {
      console.error("assignment failed for key", k, error);
    }
  }
}
function applyPluginData(n, pluginData) {
  if (pluginData === void 0) {
    return;
  }
  Object.entries(pluginData).map(([k, v]) => n.setPluginData(k, v));
}
function safeApplyLayoutMode(f, dict) {
  const { layoutMode, itemReverseZIndex, strokesIncludedInLayout } = dict;
  f.layoutMode = layoutMode;
  if (f.layoutMode !== "NONE") {
    f.itemReverseZIndex = itemReverseZIndex;
    f.strokesIncludedInLayout = strokesIncludedInLayout;
  }
}
function insert(n) {
  return __async(this, null, function* () {
    const offset = { x: 0, y: 0 };
    console.log("starting insert.");
    const [{ fontReplacements }, { availableComponents }] = yield Promise.all([
      loadFonts(fontsToLoad(n), fallbackFonts),
      loadComponents(n.components),
      loadStyles(n.styles)
    ]);
    console.log("creating images.");
    const jsonImages = Object.entries(n.images);
    const hashUpdates = /* @__PURE__ */ new Map();
    const figim = jsonImages.map(([hash, bytes]) => {
      console.log("Adding with hash: ", hash);
      const im = figma.createImage(bytes);
      hashUpdates.set(hash, im.hash);
      return [hash, im];
    });
    console.log("updating figma based on new hashes.");
    const objects = n.objects.map((n2) => updateImageHashes(n2, hashUpdates));
    console.log("inserting.");
    const insertSceneNode = (json, target) => {
      const factories = {
        RECTANGLE: () => figma.createRectangle(),
        LINE: () => figma.createLine(),
        ELLIPSE: () => figma.createEllipse(),
        POLYGON: () => figma.createPolygon(),
        STAR: () => figma.createStar(),
        VECTOR: () => figma.createVector(),
        TEXT: () => figma.createText(),
        FRAME: () => figma.createFrame(),
        COMPONENT: () => figma.createComponent(),
        INSTANCE: (componentId, availableComponents2) => {
          const component = availableComponents2[componentId];
          if (!component) {
            throw new Error("Couldn't find component");
          }
          return component.createInstance();
        }
      };
      const addToParent = (n3) => {
        if (n3 && n3.parent !== target) {
          target.appendChild(n3);
        }
      };
      let n2;
      switch (json.type) {
        case "INSTANCE":
          const _a = json, {
            type,
            children = [],
            width,
            height,
            pluginData,
            layoutMode,
            itemReverseZIndex,
            strokesIncludedInLayout,
            componentId,
            overflowDirection,
            isExposedInstance,
            componentProperties
          } = _a, rest = __objRest(_a, [
            "type",
            "children",
            "width",
            "height",
            "pluginData",
            "layoutMode",
            "itemReverseZIndex",
            "strokesIncludedInLayout",
            "componentId",
            "overflowDirection",
            "isExposedInstance",
            "componentProperties"
          ]);
          let f;
          try {
            f = factories[type](componentId, availableComponents);
          } catch (e) {
            console.error("Couldn't create instance of component", componentId);
            break;
          }
          const properties = Object.fromEntries(
            Object.entries(componentProperties).map(
              ([propertyName, { value }]) => [propertyName, value]
            )
          );
          f.setProperties(properties);
          applyOverridesToChildren(f, json);
          addToParent(f);
          safeApplyLayoutMode(f, {
            layoutMode,
            itemReverseZIndex,
            strokesIncludedInLayout
          });
          resizeOrLog(f, width, height);
          safeAssign(f, rest);
          applyPluginData(f, pluginData);
          n2 = f;
          break;
        case "FRAME":
        case "COMPONENT": {
          const _b = json, {
            type: type2,
            children: children2 = [],
            width: width2,
            height: height2,
            strokeCap,
            strokeJoin,
            pluginData: pluginData2,
            layoutMode: layoutMode2,
            itemReverseZIndex: itemReverseZIndex2,
            strokesIncludedInLayout: strokesIncludedInLayout2
          } = _b, rest2 = __objRest(_b, [
            "type",
            "children",
            "width",
            "height",
            "strokeCap",
            "strokeJoin",
            "pluginData",
            "layoutMode",
            "itemReverseZIndex",
            "strokesIncludedInLayout"
          ]);
          const f2 = factories[json.type]();
          addToParent(f2);
          safeApplyLayoutMode(f2, {
            layoutMode: layoutMode2,
            itemReverseZIndex: itemReverseZIndex2,
            strokesIncludedInLayout: strokesIncludedInLayout2
          });
          resizeOrLog(f2, width2, height2);
          safeAssign(f2, rest2);
          applyPluginData(f2, pluginData2);
          children2.forEach((c) => insertSceneNode(c, f2));
          n2 = f2;
          break;
        }
        case "GROUP": {
          const _c = json, {
            type: type2,
            children: children2 = [],
            width: width2,
            height: height2,
            pluginData: pluginData2
          } = _c, rest2 = __objRest(_c, [
            "type",
            "children",
            "width",
            "height",
            "pluginData"
          ]);
          const nodes = children2.map((c) => insertSceneNode(c, target)).filter(notUndefined);
          const f2 = figma.group(nodes, target);
          safeAssign(f2, rest2);
          n2 = f2;
          break;
        }
        case "BOOLEAN_OPERATION": {
          const _d = json, { type: type2, children: children2, width: width2, height: height2, pluginData: pluginData2 } = _d, rest2 = __objRest(_d, ["type", "children", "width", "height", "pluginData"]);
          const f2 = figma.createBooleanOperation();
          safeAssign(f2, rest2);
          applyPluginData(f2, pluginData2);
          resizeOrLog(f2, width2, height2);
          n2 = f2;
          break;
        }
        case "RECTANGLE":
        case "ELLIPSE":
        case "LINE":
        case "POLYGON":
        case "VECTOR": {
          const _e = json, { type: type2, width: width2, height: height2, pluginData: pluginData2 } = _e, rest2 = __objRest(_e, ["type", "width", "height", "pluginData"]);
          const f2 = factories[json.type]();
          safeAssign(
            f2,
            rest2
          );
          applyPluginData(f2, pluginData2);
          resizeOrLog(f2, width2, height2, true);
          n2 = f2;
          break;
        }
        case "TEXT": {
          const _f = json, { type: type2, width: width2, height: height2, fontName, pluginData: pluginData2 } = _f, rest2 = __objRest(_f, ["type", "width", "height", "fontName", "pluginData"]);
          const f2 = figma.createText();
          applyFontName(f2, fontName, fontReplacements);
          safeAssign(f2, rest2);
          applyPluginData(f2, pluginData2);
          resizeOrLog(f2, width2, height2);
          n2 = f2;
          break;
        }
        default: {
          console.log(`element type not supported: ${json.type}`);
          break;
        }
      }
      if (n2) {
        target.appendChild(n2);
      } else {
        console.warn("Unable to do anything with", json);
      }
      return n2;
    };
    return objects.map((o) => {
      const n2 = insertSceneNode(o, figma.currentPage);
      if (n2 !== void 0) {
        n2.x += offset.x;
        n2.y += offset.y;
        n2.name = `${n2.name} Copy`;
      } else {
        console.error("returned undefined for json", o);
      }
      return n2;
    }).filter(notUndefined);
  });
}

// src/figma-default-layers.ts
var defaultLayers = {
  RECTANGLE: {
    id: "_",
    name: "Rectangle",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0.8509804010391235,
          g: 0.8509804010391235,
          b: 0.8509804010391235
        }
      }
    ],
    fillStyleId: "",
    strokes: [],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "INSIDE",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [
      {
        windingRule: "NONZERO",
        data: "M0 0L100 0L100 100L0 100L0 0Z"
      }
    ],
    strokeGeometry: [],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    cornerRadius: 0,
    cornerSmoothing: 0,
    topLeftRadius: 0,
    topRightRadius: 0,
    bottomLeftRadius: 0,
    bottomRightRadius: 0,
    reactions: [],
    strokeTopWeight: 1,
    strokeBottomWeight: 1,
    strokeLeftWeight: 1,
    strokeRightWeight: 1,
    type: "RECTANGLE"
  },
  LINE: {
    id: "_",
    name: "Line",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [],
    fillStyleId: "",
    strokes: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0,
          g: 0,
          b: 0
        }
      }
    ],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "CENTER",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [],
    strokeGeometry: [
      {
        windingRule: "NONZERO",
        data: "M0 0L100 0L100 -1L0 -1L0 0Z"
      }
    ],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 0,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    reactions: [],
    type: "LINE"
  },
  ELLIPSE: {
    id: "_",
    name: "Ellipse",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0.8509804010391235,
          g: 0.8509804010391235,
          b: 0.8509804010391235
        }
      }
    ],
    fillStyleId: "",
    strokes: [],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "INSIDE",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [
      {
        windingRule: "NONZERO",
        data: "M100 50C100 77.6142 77.6142 100 50 100C22.3858 100 0 77.6142 0 50C0 22.3858 22.3858 0 50 0C77.6142 0 100 22.3858 100 50Z"
      }
    ],
    strokeGeometry: [],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    cornerRadius: 0,
    cornerSmoothing: 0,
    arcData: {
      startingAngle: 0,
      endingAngle: 6.2831854820251465,
      innerRadius: 0
    },
    reactions: [],
    type: "ELLIPSE"
  },
  POLYGON: {
    id: "_",
    name: "Polygon",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0.8509804010391235,
          g: 0.8509804010391235,
          b: 0.8509804010391235
        }
      }
    ],
    fillStyleId: "",
    strokes: [],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "INSIDE",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [
      {
        windingRule: "NONZERO",
        data: "M50 0L93.3013 75L6.69873 75L50 0Z"
      }
    ],
    strokeGeometry: [],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    cornerRadius: 0,
    cornerSmoothing: 0,
    pointCount: 3,
    reactions: [],
    type: "POLYGON"
  },
  STAR: {
    id: "_",
    name: "Star",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0.8509804010391235,
          g: 0.8509804010391235,
          b: 0.8509804010391235
        }
      }
    ],
    fillStyleId: "",
    strokes: [],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "INSIDE",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [
      {
        windingRule: "NONZERO",
        data: "M50 0L61.2257 34.5491L97.5528 34.5491L68.1636 55.9017L79.3893 90.4509L50 69.0983L20.6107 90.4509L31.8364 55.9017L2.44717 34.5491L38.7743 34.5491L50 0Z"
      }
    ],
    strokeGeometry: [],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    cornerRadius: 0,
    cornerSmoothing: 0,
    pointCount: 5,
    innerRadius: 0.3819660246372223,
    reactions: [],
    type: "STAR"
  },
  VECTOR: {
    id: "_",
    name: "Vector",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [],
    fillStyleId: "",
    strokes: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0,
          g: 0,
          b: 0
        }
      }
    ],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "CENTER",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [],
    strokeGeometry: [],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    cornerRadius: 0,
    cornerSmoothing: 0,
    vectorPaths: [],
    handleMirroring: "NONE",
    reactions: [],
    type: "VECTOR"
  },
  TEXT: {
    id: "_",
    name: "Text",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    fills: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0,
          g: 0,
          b: 0
        }
      }
    ],
    fillStyleId: "",
    strokes: [],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "OUTSIDE",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [],
    strokeGeometry: [],
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 0,
    height: 15,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    exportSettings: [],
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    characters: "",
    fontSize: 12,
    paragraphIndent: 0,
    paragraphSpacing: 0,
    textCase: "ORIGINAL",
    textDecoration: "NONE",
    letterSpacing: {
      unit: "PERCENT",
      value: 0
    },
    lineHeight: {
      unit: "AUTO"
    },
    fontName: {
      family: "Inter",
      style: "Regular"
    },
    fontWeight: 400,
    hyperlink: null,
    autoRename: true,
    textAlignHorizontal: "LEFT",
    textAlignVertical: "TOP",
    textAutoResize: "WIDTH_AND_HEIGHT",
    textStyleId: "",
    reactions: [],
    type: "TEXT"
  },
  FRAME: {
    id: "_",
    name: "Frame",
    visible: true,
    locked: false,
    componentPropertyReferences: null,
    opacity: 1,
    blendMode: "PASS_THROUGH",
    isMask: false,
    effects: [],
    effectStyleId: "",
    relativeTransform: [
      [1, 0, 0],
      [0, 1, 0]
    ],
    x: 0,
    y: 0,
    width: 100,
    height: 100,
    rotation: 0,
    layoutAlign: "INHERIT",
    constrainProportions: false,
    layoutGrow: 0,
    layoutPositioning: "AUTO",
    children: [],
    exportSettings: [],
    fills: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 1,
          g: 1,
          b: 1
        }
      }
    ],
    fillStyleId: "",
    strokes: [],
    strokeStyleId: "",
    strokeWeight: 1,
    strokeAlign: "INSIDE",
    strokeJoin: "MITER",
    dashPattern: [],
    strokeCap: "NONE",
    strokeMiterLimit: 4,
    fillGeometry: [
      {
        windingRule: "NONZERO",
        data: "M0 0L100 0L100 100L0 100L0 0Z"
      }
    ],
    strokeGeometry: [],
    cornerRadius: 0,
    cornerSmoothing: 0,
    topLeftRadius: 0,
    topRightRadius: 0,
    bottomLeftRadius: 0,
    bottomRightRadius: 0,
    paddingLeft: 0,
    paddingRight: 0,
    paddingTop: 0,
    paddingBottom: 0,
    primaryAxisAlignItems: "MIN",
    counterAxisAlignItems: "MIN",
    primaryAxisSizingMode: "AUTO",
    strokeTopWeight: 1,
    strokeBottomWeight: 1,
    strokeLeftWeight: 1,
    strokeRightWeight: 1,
    layoutGrids: [],
    gridStyleId: "",
    clipsContent: true,
    guides: [],
    expanded: true,
    constraints: {
      horizontal: "MIN",
      vertical: "MIN"
    },
    layoutMode: "NONE",
    counterAxisSizingMode: "FIXED",
    itemSpacing: 0,
    overflowDirection: "NONE",
    numberOfFixedChildren: 0,
    overlayPositionType: "CENTER",
    overlayBackground: {
      type: "NONE"
    },
    overlayBackgroundInteraction: "NONE",
    itemReverseZIndex: false,
    strokesIncludedInLayout: false,
    reactions: [],
    type: "FRAME"
  },
  PAGE: {
    id: "_",
    name: "Page",
    children: [],
    guides: [],
    selectedTextRange: null,
    backgrounds: [
      {
        type: "SOLID",
        visible: true,
        opacity: 1,
        blendMode: "NORMAL",
        color: {
          r: 0.9624999761581421,
          g: 0.9624999761581421,
          b: 0.9624999761581421
        }
      }
    ],
    exportSettings: [],
    prototypeStartNode: null,
    flowStartingPoints: [],
    prototypeBackgrounds: [
      {
        type: "SOLID",
        visible: true,
        opacity: 0,
        blendMode: "NORMAL",
        color: {
          r: 0,
          g: 0,
          b: 0
        }
      }
    ],
    type: "PAGE"
  }
};
var figma_default_layers_default = defaultLayers;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MixedValue,
  defaultLayers,
  dump,
  fontsToLoad,
  insert,
  isVisible
});
