/// <reference types="@figma/plugin-typings" />
import * as F from "./figma-json";
export declare const writeBlacklist: Set<string>;
export declare function loadFonts(requestedFonts: F.FontName[], fallbackFonts: F.FontName[]): Promise<{
    availableFonts: F.FontName[];
    missingFonts: F.FontName[];
    fontReplacements: Record<EncodedFont, EncodedFont>;
}>;
declare type EncodedFont = string;
export declare function encodeFont({ family, style }: FontName): EncodedFont;
export declare function decodeFont(f: EncodedFont): FontName;
export declare function applyFontName(n: TextNode, fontName: F.TextNode["fontName"], fontReplacements: Record<EncodedFont, EncodedFont>): Promise<void>;
export declare function getFontReplacement(missingFont: FontName, fallbackFonts: F.FontName[]): F.FontName;
export declare function fontsToLoad(n: F.DumpedFigma): FontName[];
export declare function insert(n: F.DumpedFigma): Promise<SceneNode[]>;
export {};
